#version 330

//#define INV_VIEW_NORMAL
#define NO_INVERSE
#define REFLECT

layout (std140) uniform Matrices
{
	mat4 m_pvm;
	mat4 m_viewModel;
#ifndef INV_VIEW_NORMAL
	mat4 m_view;
#else
	mat3 m_view;
#endif
	mat3 m_normal;
};

in vec4 position;	// local space
in vec3 normal;		// local space

out vec3 texCoord;

//----------------------------------------------------------------
// TODO:
// 1) Pass position to the fragment shader - renders sphere with image on it.
// 2) Pass reflected view direction in eye space - reflective sphere, camera independent.
// 3) Pass reflected view direction in world space - reflective sphere, camera dependent: texCoord = vec3(inverse(m_view) * vec4(reflectView, 0.f));
// 4) Convert the vector back to the world space by multiplying it with inverse of the view matrix.
// 5) Fix vector flip by detecting and correcting negative determinant.
// 6) Use transpose of normal_view matrix (which is inverse-transpose of the view matrix), use INV_VIEW_NORMAL define in demo.cpp.
// 7) Try refraction - needs closer skybox to be apparent.
// 8) Zoom the sphere - what happens and why?
//----------------------------------------------------------------

void main()
{
#if 1
	
#else
	// Calculate first in camera / view space.
	vec4 vertexView = m_viewModel * position;
	vec3 normalView = normalize(m_normal * normal);

	vec3 incident = vec3(vertexView);
#ifdef REFLECT
	
#else
	
#endif

	// Now go back from view space, as the cube map is in world space.
#ifdef NO_INVERSE
	
#else
#ifndef INV_VIEW_NORMAL
	
#else
	
#endif
#endif
#endif

	gl_Position = m_pvm * position;	
}