#version 330

layout (std140) uniform Matrices
{
	mat4 m_pvm;
	mat4 m_viewModel;
	mat3 m_normal;
};

layout (std140) uniform Lights
{
	vec3 l_dir;	// camera space
};

in vec4 position;	// local space
in vec3 normal;		// local space
in vec3 tangent;	// local space
in vec3 bitangent;	// local space
in vec2 texCoord;

out Data
{
	vec3 normal;
	vec3 eye;
	vec3 light;
	vec2 texCoord;
} DataOut;

//----------------------------------------------------------------
// TODO:
// 1) Transform input normal, tangent and bitangent vectors with normal matrix.
// 2) Transform light into tangent space.
// 3) Transform eye into tangent space.
// 4) Compute bitangent vector from normal and tangent instead of using the passed one.
//----------------------------------------------------------------

void main()
{
	// Transform local coordinate space into camera space
	
#if 1
	
#else
	
#endif
	DataOut.normal = n; // Not needed, send for reference

	// Transform light and eye into tangent space using this matrix:
	// tx ty tz
	// bx by bz
	// nx ny nz

	// Transform light vector from camera space to tangent space
	
	// Compute vector to camera into camera space
	vec4 vertexView = -(m_viewModel * position);
	// Convert homogeneous position into euclidean
	vec3 vertexViewEuklid = vertexView.xyz / vertexView.w;
	// Transform this vector into tangent space
	

	DataOut.texCoord = texCoord;

	gl_Position = m_pvm * position;	
}