#version 330

layout (std140) uniform Matrices
{
	mat4 m_pvm;
	mat4 m_viewModel;
	mat3 m_normal;
};

in vec4 position;	// local space
in vec3 normal;		// local space
in vec2 texCoord;

out Data
{
	vec3 normal;
	vec4 eye;
	vec2 texCoord;
} DataOut;

//----------------------------------------------------------------
// TODO:
// 1) Pass the texture coordinates to the fragment shader.
//----------------------------------------------------------------

void main()
{
	// Pass the normal and eye in camera space to the fragment shader
	DataOut.normal = normalize(m_normal * normal);
	DataOut.eye = -(m_viewModel * position);


	gl_Position = m_pvm * position;	
}